/*
 * CAN.h
 *
 *  Created on: 18. 2. 2021
 *      Author: Ondra
 */

#ifndef SRC_CAN_H_
#define SRC_CAN_H_

#include "stm32l4xx_hal.h"
#include "SMBusLib.h"

//### CAN Identifiers - viz excel


#define ID_Settings				0b01110100001
#define ID_Analog_read			0b01110100011
#define ID_Analog				0b01110000100
#define ID_Battery_period		0b01110100101 //0x3A5
#define ID_Battery_data			0b01110000110 //0x386
//SMBus
#define ID_SMB_WW				0b01110101010
#define ID_SMB_RW				0b01110101011
#define ID_SMB_RW_reply			0b01110001100
#define ID_SMB_WB_info			0b01110101101
#define ID_SMB_WB_data1			0b01110101110
#define ID_SMB_WB_data2			0b01110101111
#define ID_SMB_WB_data3			0b01110110000
#define ID_SMB_WB_data4			0b01110110001
#define ID_SMB_WB_data5			0b01110110010
#define ID_SMB_RB				0b01110110011
#define ID_SMB_RB_info			0b01110010100
#define ID_SMB_RB_data1			0b01110010101
#define ID_SMB_RB_data2			0b01110010110
#define ID_SMB_RB_data3			0b01110010111
#define ID_SMB_RB_data4			0b01110011000
#define ID_SMB_RB_data5			0b01110011001
#define ID_SMB_error			0b01110011111
#define ID_Read_base			0b01110100000
#define ID_Error				0b01110011111
#define Error_type_SMBus		0x01
#define Error_type_DLC			0x02
#define Error_type_Msg			0x04

//### CAN Identifiers end

void CAN_Filter_init(void);
void CAN_Send_Message(uint16_t ID, uint8_t DLC, uint8_t *p_buffer);
void CAN_Send_Remote(uint16_t ID);
void CAN_msg_sort(void);
void CAN_WW_handle(void);
void CAN_RW_handle(void);
void CAN_WB_handle(void);
void CAN_RB_handle(void);
void CAN_Settings_handle(void);
void CAN_Analog_handle(void);
void CAN_Battery_period_handle(void);
#endif /* SRC_CAN_H_ */
